# iricore

A Python interface to IRI-2016 and IRI-2020 using `ctypes` communication.

**The extensive documentation is available at the [RTD wbsite](https://iricore.readthedocs.io/en/latest).**

## Installation

This package proved to work under Linux only (due to compilation difficulties in Windows).
If you are using Windows - consider installing [WSL](https://docs.microsoft.com/en-us/windows/wsl/install).

### Prerequisites

- CMAKE

```
sudo apt instal cmake
```

- Fortran compiler, e.g. `gfortran`

```
sudo apt isntall gfortran
```

### Installing package

Now you can simply install it via `pip`:

```
python3 -m pip install iricore
```

## Data files

`IRI2016` model depends on [data files](http://irimodel.org/indices/) which are regularly updated.
`iricore` does not autoupdate those, but provides tool for quick update. You can run from terminal

```
python3 -c "import iricore; iricore.update()"
```

or add

```
import iricore
iricore.update()
```

to any Python script.

		International Reference Ionosphere Software (Aug 5, 2022)
		----------------------------------------------------------

================================================================================

The IRI is a joined project of the Committee on Space Research (COSPAR) and the 
International Union of Radio Science (URSI). IRI is an empirical model specifying
monthly averages of electron density, ion composition, electron temperature, and 
ion temperature in the altitude range from 50 km to 1500 km.

This directory includes the FORTRAN program, coefficients, and indices files for 
the latest version of the International Reference Ionosphere model: IRI2012. This
version includes several options for different parts and parameters. A logical
array JF(30) is used to set these options. The IRI-recommended set of options
can be found in the COMMENT section at the beginning of IRISUB.FOR. IRITEST.FOR 
sets these options as the default.

The compilation/link command in Fortran 77 is:
f77 -o iri iritest.for irisub.for irifun.for iritec.for iridreg.for igrf.for 
 cira.for iriflip.for rocdrift.for
 
Directory Contents:
-----------------------------------------------------------------------------------

00_iri.tar		TAR file that includes all files from this directory and that was 
                created in UNIX using 'tar -cvf 00_iri.tar *'. UNIX command to 
                unpack is "tar -xvf 00_iri.tar". 
				 
irisub.for      This file contains the main subroutine iri_sub. It computes 
                height profiles if IRI output parameters (Ne, Te, Ti, Ni, vi) 
                for specified date and location. Also included is the 
                subroutine iri_web that computes output parameters versus
                latitude, longitude (geog. or geom.), year, day of year, hour 
                (LT or UT), and month. An example of how to call and use iri_web 
                is shown in iritest.for. Compilation of iritest.for requires
                irisub.for, irifun.for, iritec.for, iridreg.for, igrf.for, and
                cira.for.

irifun.for      This file contains the subroutines and functions that are 
                required for running IRI.


iriflip.for     Subroutines for the FLIP-related new model for the bottomside
                ion composition of Richards et al.
                
iridreg.for     Subroutines for the D region models of Friedrich-Torkar
                and of Danilov et al.

iritec.for      This file includes the subroutines for computing the ionospheric 
                electron content from 60km up to a specified upper limit. 

rocdrift.for    Equatorial vertical ion drift model of Fejer et al. (2009)

cira.for        This file includes the subroutines and functions for computing 
                the COSPAR International Reference Ionosphere (NRLMSIS-00) 
                neutral temperature and densities. 

igrf.for        This file includes the subroutines for the International
                Geomagnetic Reference Field (IGRF).

dgrf%%%%.dat    Definitive IGRF coefficients for the years 1945 to 2010 in steps
                of 5 years (%%%%=1945, 1950, etc.)(ASCII).
igrf%%%%.dat    Prelimenary IGRF coefficients for most recent year (ASCII).
igrf%%%%s.dat   IGRF coefficients for extrapolating 5 years into the future (ASCII).
 
MCSAT%%.dat     Monthly coefficient files for the Shubin(2015) COSMIC-based hmF2 model
                %%=month+10
                
iritest.for     Test program indicating how to use of the IRI subroutines. 
                Requires irisub, irifun, iritec, iridreg, igrf,and cira.
                
IN ADDITION THE FOLLOWING COEFFICIENTS AND INDICES FILES ARE REQUIRED THAT ARE NOT INCLUDED IN THIS DIRECTORY. THESE FILES ARE AVAILABLE ON THE IRI HOMEPAGE IRIMODEL.ORG:

Indices files at http://irimodel.org/indices/:
ig_rz.dat       This file(s) contains the solar and ionospheric indices (IG12, Rz12) 
                for the time period from Jan 1958 onward. The file is updated 
                quarterly. It is read by subroutine tcon in irifun.for (ASCII). 
                [This file will be updated at close to quarterly intervals]                
apf107.dat      This file provides the 3-hour ap magnetic index and F10.7 daily
                81-day and 365-day index from 1960 onward (ASCII).
                [This file will be updated at close to quarterly intervals]
Daily updates of these two files are available from the ECHAIM website (David 
Themens) as described on irimodel.org.

Coefficients files at http://irimodel.org/COMMON_FILES/:
CCIR%%.dat		Monthly coefficient files for the CCIR foF2 and M(3000)F2 models
                %%=month+10
URSI%%.dat		Monthly coefficient files for the URSI foF2 model
                %%=month+10

-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------

NOTE: Please consult the 'listing of changes' in the comments section at the top 
of each one of these programs for recent corrections and improvements.

More information about the IRI project can be found at irimodel.org including
access to sites that allow online computation and plotting of IRI parameters. 

The IRI output parameters are described at irimodel.org/IRI-output-arrays.docs
The available options are described at irimodel.org/IRI-Switches-options.docs
Answers to Frequently Asked Questions are available at irimodel.org/docs/IRI_FAQ.pdf

----------------------------- dbilitza@gmu.edu -------------------------------------

!subroutine iricore(jf, jmag, glat, glon, gsize, iyyyy, mmdd, dhour, heibeg, heiend, heistp, oarr, iri_res, datadir, ddsize)
subroutine iricore(jf, jmag, glat, glon, gsize, iyyyy, mmdd, dhour, heibeg, heiend, heistp, oarr, iri_res, datadir)
  logical, intent(in) :: jf(50)
  logical, intent(in) :: jmag
  integer, intent(in) :: gsize
  real,  intent(in) :: glat(gsize), glon(gsize)
  integer, intent(in) :: iyyyy, mmdd
  real, intent(in) :: dhour, heibeg, heiend, heistp
  real, intent(inout) :: oarr(100)
  real, intent(inout) :: iri_res(20, 1000, gsize)
!  integer, intent(in) :: ddsize
!  character(ddsize), intent(in) :: datadir
  character(*), intent(in) :: datadir
  real :: outf(20,1000)
  character(256) :: datadir1
  common /folders/ datadir1
  integer :: i, k, j
  integer :: NITER

  datadir1 = datadir
  call read_ig_rz
  call readapf107
  NITER = SIZE(glat)

  do i = 1, NITER
      call IRI_SUB(jf, jmag, glat(i), glon(i), iyyyy, mmdd, dhour, heibeg, heiend, heistp, outf, oarr, datadir)
!      do j = 1, 20
!        do k = 1, 1000
!          iri_res(j, k, i) = outf(j, k)
!        end do
!      end do
  end do
return
end

c  irirtam-test.for
c --------------------------------------------------------------- 
c  Test program for the IRI subroutines READIRTAMCOF, FOUT1,
c  and GAMMA2 that read the IRTAM coefficients and calculate
c  NmF2, hmF2, and B0 for the Real-Time IRI.
c --------------------------------------------------------------- 
C  2016.01 06/17/16 First release       
C  2017.01 11/03/17 Added B1 input      
c --------------------------------------------------------------- 
c 
		Real ff2(1064),fh2(1064),fb0(1064),fb1(1064)
        COMMON/CONST/UMR,PI
                
        pi=ATAN(1.0)*4.
        UMR=pi/180.

		idate=20160523
		alati=-11.95
		along=283.13
		ryear=2016.6
c        call igrf_dip(alati,along,ryear,300.0,dec,dip,xmagbr,xmodip)
        xmodip=-0.37
                
		hourut=0.0
		tov=12
		itovhm=1200
		
		call READIRTAMCOF(0,idate,itovhm,1064,ff2)
		call READIRTAMCOF(1,idate,itovhm,1064,fh2)
		call READIRTAMCOF(2,idate,itovhm,1064,fb0)
c		call READIRTAMCOF(3,idate,itovhm,1064,fb1)
		
1122	fof2rt=FOUT1(XMODIP,ALATI,ALONG,HOURUT,TOV,ff2)
		hmf2rt=FOUT1(XMODIP,ALATI,ALONG,HOURUT,TOV,fh2)
		B0rt=FOUT1(XMODIP,ALATI,ALONG,HOURUT,TOV,fb0)
c		B1rt=FOUT1(XMODIP,ALATI,ALONG,HOURUT,TOV,fb1)

		print*,idate,hourut,itovhm,fof2rt,hmf2rt,B0rt
c		print*,idate,hourut,itovhm,fof2rt,hmf2rt,B0rt,B1rt
		hourut=hourut+1.0	
		if(hourut.lt.18.0) goto 1122
		stop
		end
c

subroutine iricore(jf, jmag, glat, glon, gsize, iyyyy, mmdd, dhour, heibeg, heiend, heistp, oarr, iri_res, datadir, &
        ddsize)
    !                   ddsize, aap_, af107_, n_)
    logical, intent(in) :: jf(50)
    logical, intent(in) :: jmag
    integer, intent(in) :: gsize
    real, intent(in) :: glat(gsize), glon(gsize)
    integer, intent(in) :: iyyyy, mmdd
    real, intent(in) :: dhour, heibeg, heiend, heistp
    real, intent(inout) :: oarr(100)
    real, intent(inout) :: iri_res(20, 1000, gsize)
    integer, intent(in) :: ddsize
    character(ddsize), intent(in) :: datadir
    !  integer, intent(in) :: aap_(27000, 9)
    !  real, intent(in) :: af107_(27000, 3)
    !  integer, intent(in) :: n_

    integer :: aap(27000, 9)
    real :: af107(27000, 3)
    integer :: n
    common /apfa/aap, af107, n
    real :: outf(20, 1000)
    character(256) :: datadir1
    common /folders/ datadir1
    integer :: i, k, j
    integer :: NITER

  aap = aap_
  af107 = af107_
  n = n_
  datadir1 = datadir
  call read_ig_rz
  ! TODO: Remove next line later (after applying the fix)
  call readapf107
  NITER = SIZE(glat)


  do i = 1, NITER
      call IRI_SUB(jf, jmag, glat(i), glon(i), iyyyy, mmdd, dhour, heibeg, heiend, heistp, outf, oarr, datadir)
      do j = 1, 20
        do k = 1, 1000
          iri_res(j, k, i) = outf(j, k)
        end do
      end do
  end do
return
end

c  irirtam.for
c --------------------------------------------------------------- 
c  IRI subroutines READIRTAMCOF, FOUT1, and GAMMA2 that read the 
c  IRTAM coefficients and calculate NmF2, hmF2, and B0 for the 
c  Real-Time IRI. The process of assimilating ionsonde and 
c  Digisonde data into a Real-Time IRI is described in: Galkin et 
c  al.,Radio Sci., 47, RS0L07, doi:10.1029/2011RS004952, 2012.
c --------------------------------------------------------------- 
C  2016.01 06/17/16 First release       
C  2016.02 11/03/17 Added B1 input
C  2016.03 12/20/19 Correct directory and name for IRTAM coeffs
C      
c --------------------------------------------------------------- 
c 

		SUBROUTINE READIRTAMCOF(ISEL,IDATE,IHHMM,MFF,FF)
C -----------------------------------------------------------
C Finds and reads IRTAM coefficients for foF2, hmF2, B0, and 
C B1 for date IDATE (yyyymmdd) and time HOURUT (decimal hours, 
C Universal Time): 
C ISEL parameter   filename
C   0    foF2    IRTAM_foF2_COEFFS_yyyymmdd_hhmm.asc 
C   1    hmF2    IRTAM_hmF2_COEFFS_yyyymmdd_hhmm.asc 
C   2    B0      IRTAM_B0in_COEFFS_yyyymmdd_hhmm.asc
C   3    B1      IRTAM_B1in_COEFFS_yyyymmdd_hhmm.asc
c The coefficient array is stored in FF(MFF).
C D. Bilitza, Jun 17.2016
C Added B1 input      D. Bilitza, Nov 3, 2017
C -----------------------------------------------------------
 
c		CHARACTER	FILNAM*28
		integer		iuccir
		CHARACTER*100	FILNAM
		CHARACTER*120	LINE
		CHARACTER*12    INAME
		DIMENSION 	    FF(MFF)
        konsol=6

        IUCCIR=10
		iname='foF2_COEFFS_'
		if(isel.gt.0) iname='hmF2_COEFFS_'
		if(isel.gt.1) iname='B0in_COEFFS_'
		if(isel.gt.2) iname='B1in_COEFFS_'

c read foF2 coefficients 
     
        WRITE(FILNAM,104) iname,idate,ihhmm
ccc104     FORMAT('/home/bilitza/tango_home/IRI_data/iri/',
ccc     &     'iri_dev/IRTAM_dir/IRTAM_',A12,I8,'_',I4.4,'.ASC')
104     FORMAT('IRTAM_',A12,I8,'_',I4.4,'.ASC')
        OPEN(IUCCIR,FILE=FILNAM,STATUS='OLD',ERR=201,
     &          FORM='FORMATTED', action='read')
     	print*,mff,filnam

C skip header with comments
c	    do 1,13 READ(iuccir,1289) LINE
4686	READ(iuccir,1289) LINE
1289	Format(A120)
		if(LINE(1:12).NE."# END_HEADER") goto 4686

c read coefficients			
        READ(iuccir,4689) FF
4699    FORMAT(E16.8)
4689    FORMAT(4E16.8)
4690    CLOSE(10)
	
		goto 300
		
201     WRITE(6,203) FILNAM
203     FORMAT(1X////,
     &    ' The file ',A100,' is not in your directory.')
		
300		CONTINUE
		RETURN
		END
C
C
      real function FOUT1(XMODIP,XLATI,XLONGI,UT,TOV,FF0)
c--------------------------------------------------------------
C CALCULATES CRITICAL FREQUENCY FOF2/MHZ USING SUBROUTINE GAMMA2.      
C XMODIP = MODIFIED DIP LATITUDE, XLATI = GEOG. LATITUDE, XLONGI=
C LONGITUDE (ALL IN DEG.), MONTH = MONTH, UT =  UNIVERSAL TIME 
C (DEC. HOURS), FF0 = ARRAY WITH RZ12-ADJUSTED CCIR/URSI COEFF.
C D.BILITZA,JULY 85.
C Modified to accept IRTAM coefficients FFO and TOV
C D. Bilitza, Jun 17.2016
c--------------------------------------------------------------
      DIMENSION FF0(1064)
      INTEGER QF(9)
      DATA QF/11,11,8,4,1,0,0,0,0/
      FOUT1=GAMMA2(XMODIP,XLATI,XLONGI,UT,TOV,6,QF,9,76,13,1064,FF0)
      RETURN
      END
C
C
        REAL FUNCTION GAMMA2(SMODIP,SLAT,SLONG,HOUR,TOV,
     &                          IHARM,NQ,K1,M,MM,M3,SFE)      
C---------------------------------------------------------------
C CALCULATES GAMMA2=FOF2 OR M3000 USING CCIR NUMERICAL MAP                      
C COEFFICIENTS SFE(M3) FOR MODIFIED DIP LATITUDE (SMODIP/DEG)
C GEOGRAPHIC LATITUDE (SLAT/DEG) AND LONGITUDE (SLONG/DEG)  
C AND UNIVERSIAL TIME (HOUR/DECIMAL HOURS). IHARM IS THE MAXIMUM
C NUMBER OF HARMONICS USED FOR DESCRIBING DIURNAL VARIATION.
C NQ(K1) IS AN INTEGER ARRAY GIVING THE HIGHEST DEGREES IN 
C LATITUDE FOR EACH LONGITUDE HARMONIC WHERE K1 GIVES THE NUMBER 
C OF LONGITUDE HARMONICS. M IS THE NUMBER OF COEFFICIENTS FOR 
C DESCRIBING VARIATIONS WITH SMODIP, SLAT, AND SLONG. MM IS THE
C NUMBER OF COEFFICIENTS FOR THE FOURIER TIME SERIES DESCRIBING
C VARIATIONS WITH UT.
C M=1+NQ(1)+2*[NQ(2)+1]+2*[NQ(3)+1]+... , MM=2*IHARM+1, M3=M*MM  
C SHEIKH,4.3.77.
C Modified to accept IRTAM coefficients SFE(M3) and TOV
C D. Bilitza, Jun 17.2016
C---------------------------------------------------------------
      REAL*8 C(12),S(12),COEF(100),SUM             
      DIMENSION NQ(K1),XSINX(13),SFE(M3)           
      COMMON/CONST/UMR,PI
      
      XMIN=(HOUR-TOV)*60.+720                    
      HOU=(15.0*HOUR-180.0)*UMR                    
      S(1)=SIN(HOU)   
      C(1)=COS(HOU)   

      DO 250 I=2,IHARM                             
        C(I)=C(1)*C(I-1)-S(1)*S(I-1)                 
        S(I)=C(1)*S(I-1)+S(1)*C(I-1)                 
250     CONTINUE        

      MMM=M*MM
      DO 300 I=1,M    
        MI=(I-1)*MM     
        COEF(I)=SFE(MI+1)                            
        DO 301 J=1,IHARM                             
          COEF(I)=COEF(I)+SFE(MI+2*J)*S(J)+SFE(MI+2*J+1)*C(J)                       
301       CONTINUE
        COEF(I)=COEF(I)+SFE(MMM+I)*XMIN                                      
300     CONTINUE        
        
      SUM=COEF(1)     
      SS=SIN(SMODIP*UMR)                           
      S3=SS           
      XSINX(1)=1.0    
      INDEX=NQ(1)     

      DO 350 J=1,INDEX                             
        SUM=SUM+COEF(1+J)*SS                         
        XSINX(J+1)=SS   
        SS=SS*S3        
350     CONTINUE        

      XSINX(NQ(1)+2)=SS                            
      NP=NQ(1)+1      
      SS=COS(SLAT*UMR)                             
      S3=SS           

      DO 400 J=2,K1   
        S0=SLONG*(J-1.)*UMR                          
        S1=COS(S0)      
        S2=SIN(S0)      
        INDEX=NQ(J)+1   
        DO 450 L=1,INDEX                             
          NP=NP+1         
          SUM=SUM+COEF(NP)*XSINX(L)*SS*S1              
          NP=NP+1         
          SUM=SUM+COEF(NP)*XSINX(L)*SS*S2              
450       CONTINUE        
        SS=SS*S3        
400     CONTINUE
        
      GAMMA2=SUM      

      RETURN          
      END 
C
C

subroutine iricore(jf, jmag, glat, glon, gsize, iyyyy, mmdd, dhour, heibeg, heiend, heistp, oarr, iri_res)
  logical, intent(in) :: jf(50)
  logical, intent(in) :: jmag
  integer, intent(in) :: gsize
  real,  intent(in) :: glat(gsize), glon(gsize)
  integer, intent(in) :: iyyyy, mmdd
  real, intent(in) :: dhour, heibeg, heiend, heistp
  real, intent(inout) :: oarr(100)
  real, intent(inout) :: iri_res(20, 1000, gsize)

  real :: outf(20,1000)
  integer :: i, k, j
  integer :: NITER

!  call read_ig_rz
!  call readapf107
  NITER = SIZE(glat)


  do i = 1, NITER
      call IRI_SUB(jf, jmag, glat(i), glon(i), iyyyy, mmdd, dhour, heibeg, heiend, heistp, outf, oarr)
      do j = 1, 20
        do k = 1, 1000
          iri_res(j, k, i) = outf(j, k)
        end do
      end do
  end do
return
end

program test
    logical :: jf(50) = .true.
    logical :: jmag
    integer :: gsize = 1000
    real :: glat(1000), glon(1000)
    integer :: iyyyy = 2015
    integer :: mmdd = 101
    real :: dhour = 5.
    real :: heibeg = 150.
    real :: heiend = 500.
    real :: heistp = 10.
    real :: oarr(100)
    real :: iri_res(20, 1000, 1000)
    character(256) :: datadir = "data/data16"
    integer :: jffalse(16)
    jffalse =  (/2, 3, 4, 5, 11, 21, 22, 25, 27, 28, 29, 33, 34, 35, 36, 47/)
    do i = 1, gsize
        glat(i) = 90.0
        glon(i) = 0.0
    end do
    do i = 1, size(jffalse)
        jf(jffalse(i)) = .false.
    end do
    call iricore(jf, jmag, glat, glon, gsize, iyyyy, mmdd, dhour, heibeg, heiend, heistp, oarr, iri_res, datadir)
!    print *, oarr
end program test

subroutine stec(jf, jmag, lat, lon, heights, hsize, iyyyy, mmdd, dhour, oarr, iri_res, datadir, &
        ddsize)
    !                   ddsize, aap_, af107_, n_)
    logical, intent(in) :: jf(50)
    logical, intent(in) :: jmag
    integer, intent(in) :: hsize
    real, intent(in) :: lat(hsize), lon(hsize), heights(hsize)
    integer, intent(in) :: iyyyy, mmdd
    real, intent(in) :: dhour
    real, intent(inout) :: oarr(100)
    real, intent(inout) :: iri_res(20, 1000, hsize)
    integer, intent(in) :: ddsize
    character(ddsize), intent(in) :: datadir
    !  integer, intent(in) :: aap_(27000, 9)
    !  real, intent(in) :: af107_(27000, 3)
    !  integer, intent(in) :: n_

    integer :: aap(27000, 9)
    real :: af107(27000, 3)
    integer :: n
    common /apfa/aap, af107, n
    real :: outf(20, 1000)
    character(256) :: datadir1
    common /folders/ datadir1
    integer :: i, k, j
    integer :: NITER

  aap = aap_
  af107 = af107_
  n = n_
  datadir1 = datadir
  call read_ig_rz
    call readapf107
  NITER = SIZE(heights)


  do i = 1, NITER
      call IRI_SUB(jf, jmag, lat(i), lon(i), iyyyy, mmdd, dhour, heights(i), heights(i), 1., outf, oarr, datadir)
      do j = 1, 20
        iri_res(j, 1, i) = outf(j, 1)
      end do
  end do
return
end
